FROM cocainefarm/stack-musl as hpack

# Clone hpack
RUN git clone https://github.com/sol/hpack --branch 0.33.0 --single-branch /work

WORKDIR /work

# Build
RUN hpack
RUN cabal new-update
RUN cabal install --ghc-options='-optl-static -fPIC -optc-Os'


# USE ALPINE LINUX
FROM alpine

# INSTALL BASIC DEV TOOLS, GHC, GMP & ZLIB
RUN apk update
RUN apk add --no-cache alpine-sdk git ca-certificates tar xz musl-dev linux-headers shadow upx
RUN apk add --no-cache ghc=8.4.3-r0 cabal=2.4.1.0-r0

# Copy hpack from hpack build stage
COPY --from=hpack /root/.cabal/bin/hpack /usr/local/bin/hpack
